<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><title>Python: module ColorMix3R</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head><body bgcolor="#f0f0f8">

<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="heading">
<tr bgcolor="#7799ee">
<td valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial">&nbsp;<br><big><big><strong>ColorMix3R</strong></big></big></font></td
><td align=right valign=bottom
><font color="#ffffff" face="helvetica, arial"><a href=".">index</a><br><a href="file:c%3A%5Cusers%5Cmarc%5Cpycharmprojects%5Ccolormix3r%5Ccolormix3r.py">c:\users\marc\pycharmprojects\colormix3r\colormix3r.py</a></font></td></tr></table>
    <p><tt>#&nbsp;-*-&nbsp;coding:&nbsp;utf-8&nbsp;-*-<br>
#<br>
#&nbsp;&nbsp;&nbsp;&nbsp;ColorMix3R.xpy,&nbsp;Designed&nbsp;for&nbsp;the&nbsp;Cyclops&nbsp;(2-in,&nbsp;1-out)<br>
#&nbsp;&nbsp;&nbsp;&nbsp;and&nbsp;Diamond&nbsp;(3-in,&nbsp;1-out)&nbsp;3D-Print&nbsp;heads.<br>
#<br>
#&nbsp;&nbsp;&nbsp;&nbsp;A&nbsp;post-processing&nbsp;script&nbsp;written&nbsp;in&nbsp;Python.&nbsp;&nbsp;It&nbsp;adds&nbsp;color&nbsp;mixing<br>
#&nbsp;&nbsp;&nbsp;&nbsp;control&nbsp;to&nbsp;in&nbsp;a&nbsp;batch&nbsp;(from&nbsp;the&nbsp;command&nbsp;line).&nbsp;&nbsp;In&nbsp;Slic3r&nbsp;the<br>
#&nbsp;&nbsp;&nbsp;&nbsp;post-processing&nbsp;can&nbsp;be&nbsp;integrated&nbsp;seamlessly.<br>
#<br>
#&nbsp;&nbsp;&nbsp;&nbsp;Copyright&nbsp;2019&nbsp;Floating&nbsp;Cameras,&nbsp;LLC&nbsp;-&nbsp;Author:&nbsp;Marc&nbsp;Cole<br>
#<br>
#&nbsp;&nbsp;&nbsp;&nbsp;Licensed&nbsp;under&nbsp;the&nbsp;Apache&nbsp;License,&nbsp;Version&nbsp;2.0&nbsp;(the&nbsp;"License");<br>
#&nbsp;&nbsp;&nbsp;&nbsp;you&nbsp;may&nbsp;not&nbsp;use&nbsp;this&nbsp;file&nbsp;except&nbsp;in&nbsp;compliance&nbsp;with&nbsp;the&nbsp;License.<br>
#&nbsp;&nbsp;&nbsp;&nbsp;You&nbsp;may&nbsp;obtain&nbsp;a&nbsp;copy&nbsp;of&nbsp;the&nbsp;License&nbsp;at<br>
#<br>
#&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</a><br>
#<br>
#&nbsp;&nbsp;&nbsp;&nbsp;Unless&nbsp;required&nbsp;by&nbsp;applicable&nbsp;law&nbsp;or&nbsp;agreed&nbsp;to&nbsp;in&nbsp;writing,&nbsp;software<br>
#&nbsp;&nbsp;&nbsp;&nbsp;distributed&nbsp;under&nbsp;the&nbsp;License&nbsp;is&nbsp;distributed&nbsp;on&nbsp;an&nbsp;"AS&nbsp;IS"&nbsp;BASIS,<br>
#&nbsp;&nbsp;&nbsp;&nbsp;WITHOUT&nbsp;WARRANTIES&nbsp;OR&nbsp;CONDITIONS&nbsp;OF&nbsp;ANY&nbsp;KIND,&nbsp;either&nbsp;express&nbsp;or&nbsp;implied.<br>
#&nbsp;&nbsp;&nbsp;&nbsp;See&nbsp;the&nbsp;License&nbsp;for&nbsp;the&nbsp;specific&nbsp;language&nbsp;governing&nbsp;permissions&nbsp;and<br>
#&nbsp;&nbsp;&nbsp;&nbsp;limitations&nbsp;under&nbsp;the&nbsp;License.</tt></p>
<p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#aa55cc">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Modules</strong></big></font></td></tr>
    
<tr><td bgcolor="#aa55cc"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><table width="100%" summary="list"><tr><td width="25%" valign=top><a href="argparse.html">argparse</a><br>
</td><td width="25%" valign=top><a href="math.html">math</a><br>
</td><td width="25%" valign=top><a href="os.html">os</a><br>
</td><td width="25%" valign=top><a href="re.html">re</a><br>
</td></tr></table></td></tr></table><p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ee77aa">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Classes</strong></big></font></td></tr>
    
<tr><td bgcolor="#ee77aa"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><dl>
<dt><font face="helvetica, arial"><a href="builtins.html#object">builtins.object</a>
</font></dt><dd>
<dl>
<dt><font face="helvetica, arial"><a href="ColorMix3R.html#ColorBand">ColorBand</a>
</font></dt><dt><font face="helvetica, arial"><a href="ColorMix3R.html#ColorGCoder">ColorGCoder</a>
</font></dt><dt><font face="helvetica, arial"><a href="ColorMix3R.html#EMix">EMix</a>
</font></dt><dt><font face="helvetica, arial"><a href="ColorMix3R.html#RunValues">RunValues</a>
</font></dt></dl>
</dd>
</dl>
 <p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ffc8d8">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#000000" face="helvetica, arial"><a name="ColorBand">class <strong>ColorBand</strong></a>(<a href="builtins.html#object">builtins.object</a>)</font></td></tr>
    
<tr><td bgcolor="#ffc8d8"><tt>&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%">Methods defined here:<br>
<dl><dt><a name="ColorBand-__init__"><strong>__init__</strong></a>(self, pi_layer_count:int, pi_pattern_idx:int, pi_start_layer:int, pf_layer_height:float=0.2)</dt><dd><tt>Initialize&nbsp;self.&nbsp;&nbsp;See&nbsp;help(type(self))&nbsp;for&nbsp;accurate&nbsp;signature.</tt></dd></dl>

<hr>
Data descriptors defined here:<br>
<dl><dt><strong>__dict__</strong></dt>
<dd><tt>dictionary&nbsp;for&nbsp;instance&nbsp;variables&nbsp;(if&nbsp;defined)</tt></dd>
</dl>
<dl><dt><strong>__weakref__</strong></dt>
<dd><tt>list&nbsp;of&nbsp;weak&nbsp;references&nbsp;to&nbsp;the&nbsp;object&nbsp;(if&nbsp;defined)</tt></dd>
</dl>
<dl><dt><strong>actual_height</strong></dt>
<dd><tt>Read-oly&nbsp;calculated&nbsp;value<br>
:return:&nbsp;Build&nbsp;height&nbsp;based&nbsp;on&nbsp;layer_height&nbsp;which&nbsp;could&nbsp;be&nbsp;slightly&nbsp;smaller&nbsp;if<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;height&nbsp;was&nbsp;set&nbsp;instead&nbsp;of&nbsp;layer_count</tt></dd>
</dl>
<dl><dt><strong>end_height</strong></dt>
<dd><tt>Read-oly&nbsp;calculated&nbsp;value<br>
&nbsp;<br>
:return:&nbsp;Build&nbsp;height&nbsp;in&nbsp;mm</tt></dd>
</dl>
<dl><dt><strong>end_layer</strong></dt>
<dd><tt>Read-only&nbsp;calculated&nbsp;value<br>
&nbsp;<br>
:return:&nbsp;The&nbsp;end&nbsp;layer&nbsp;number</tt></dd>
</dl>
<dl><dt><strong>layer_count</strong></dt>
<dd><tt>Assure&nbsp;value&nbsp;is&nbsp;set&nbsp;since&nbsp;it&nbsp;is&nbsp;often&nbsp;unknown&nbsp;at&nbsp;instance&nbsp;init<br>
&nbsp;<br>
:return:&nbsp;Number&nbsp;of&nbsp;layers&nbsp;in&nbsp;this&nbsp;band</tt></dd>
</dl>
<dl><dt><strong>start_height</strong></dt>
<dd><tt>Read-oly&nbsp;calculated&nbsp;value<br>
&nbsp;<br>
:return:&nbsp;Starting&nbsp;height&nbsp;in&nbsp;mm&nbsp;for&nbsp;this&nbsp;band</tt></dd>
</dl>
</td></tr></table> <p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ffc8d8">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#000000" face="helvetica, arial"><a name="ColorGCoder">class <strong>ColorGCoder</strong></a>(<a href="builtins.html#object">builtins.object</a>)</font></td></tr>
    
<tr><td bgcolor="#ffc8d8"><tt>&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%">Methods defined here:<br>
<dl><dt><a name="ColorGCoder-__init__"><strong>__init__</strong></a>(self, ps_infile_name:str, ps_outfile_name:str=None)</dt><dd><tt>Initialize&nbsp;self.&nbsp;&nbsp;See&nbsp;help(type(self))&nbsp;for&nbsp;accurate&nbsp;signature.</tt></dd></dl>

<dl><dt><a name="ColorGCoder-colorize"><strong>colorize</strong></a>(self)</dt><dd><tt>Process&nbsp;the&nbsp;input&nbsp;file&nbsp;line&nbsp;by&nbsp;line.<br>
&nbsp;<br>
:return:</tt></dd></dl>

<dl><dt><a name="ColorGCoder-metascan"><strong>metascan</strong></a>(self, buf_size=8192)</dt><dd><tt>Reading&nbsp;from&nbsp;the&nbsp;end&nbsp;of&nbsp;the&nbsp;file&nbsp;work&nbsp;backwards&nbsp;for&nbsp;three&nbsp;buffer&nbsp;sizes&nbsp;of&nbsp;text&nbsp;and<br>
extract&nbsp;and&nbsp;save&nbsp;all&nbsp;of&nbsp;the&nbsp;value-paris&nbsp;seen.<br>
&nbsp;<br>
In&nbsp;Slic3r&nbsp;this&nbsp;is&nbsp;necessary&nbsp;to&nbsp;obtain&nbsp;the&nbsp;layer_count&nbsp;(or&nbsp;build_height).&nbsp;Cura&nbsp;has<br>
a&nbsp;build&nbsp;height&nbsp;variable&nbsp;so&nbsp;this&nbsp;step&nbsp;is&nbsp;not&nbsp;necessary&nbsp;for&nbsp;a&nbsp;Cura&nbsp;file.<br>
&nbsp;<br>
&nbsp;NOTE:&nbsp;This&nbsp;is&nbsp;a&nbsp;post-processing&nbsp;script&nbsp;for&nbsp;&nbsp;Slic3r.&nbsp;I&nbsp;don't&nbsp;use&nbsp;Cura&nbsp;except&nbsp;for<br>
&nbsp;testing&nbsp;but&nbsp;ColorBlender&nbsp;can&nbsp;be&nbsp;run&nbsp;from&nbsp;the&nbsp;command&nbsp;line&nbsp;and&nbsp;I&nbsp;have&nbsp;tested&nbsp;with<br>
&nbsp;a&nbsp;Cura&nbsp;generated&nbsp;file.&nbsp;To&nbsp;work&nbsp;seamlessly&nbsp;with&nbsp;Cura&nbsp;this&nbsp;code&nbsp;would&nbsp;have&nbsp;to&nbsp;be<br>
&nbsp;converted&nbsp;to&nbsp;a&nbsp;Cura&nbsp;plug-in.<br>
&nbsp;<br>
:param&nbsp;buf_size:&nbsp;Size&nbsp;in&nbsp;bytes&nbsp;to&nbsp;buffer.&nbsp;&nbsp;Three&nbsp;buffers&nbsp;of&nbsp;text&nbsp;will&nbsp;be&nbsp;processed.<br>
:return:</tt></dd></dl>

<dl><dt><a name="ColorGCoder-process_line"><strong>process_line</strong></a>(self, line, fout)</dt><dd><tt>Give&nbsp;a&nbsp;line&nbsp;process&nbsp;as&nbsp;a&nbsp;sequential&nbsp;command&nbsp;to&nbsp;detect&nbsp;meta-data&nbsp;prior&nbsp;to&nbsp;Layer:&nbsp;0<br>
and&nbsp;retractions&nbsp;and&nbsp;layer&nbsp;changes&nbsp;after&nbsp;Layer:0<br>
&nbsp;<br>
When&nbsp;a&nbsp;retraction&nbsp;is&nbsp;seen&nbsp;insert&nbsp;the&nbsp;'Equal&nbsp;Mix'&nbsp;command&nbsp;and&nbsp;additional&nbsp;retraction&nbsp;/&nbsp;unretracts<br>
to&nbsp;keep&nbsp;the&nbsp;filament&nbsp;properly&nbsp;positioned.&nbsp;&nbsp;Change&nbsp;the&nbsp;color&nbsp;mix&nbsp;according&nbsp;to&nbsp;the&nbsp;pattern&nbsp;/&nbsp;colorwheel&nbsp;.<br>
&nbsp;<br>
:param&nbsp;line:&nbsp;Line&nbsp;of&nbsp;gcode&nbsp;from&nbsp;the&nbsp;input&nbsp;stream<br>
:param&nbsp;fout:&nbsp;Output&nbsp;file&nbsp;handler<br>
:return:</tt></dd></dl>

<hr>
Data descriptors defined here:<br>
<dl><dt><strong>__dict__</strong></dt>
<dd><tt>dictionary&nbsp;for&nbsp;instance&nbsp;variables&nbsp;(if&nbsp;defined)</tt></dd>
</dl>
<dl><dt><strong>__weakref__</strong></dt>
<dd><tt>list&nbsp;of&nbsp;weak&nbsp;references&nbsp;to&nbsp;the&nbsp;object&nbsp;(if&nbsp;defined)</tt></dd>
</dl>
</td></tr></table> <p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ffc8d8">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#000000" face="helvetica, arial"><a name="EMix">class <strong>EMix</strong></a>(<a href="builtins.html#object">builtins.object</a>)</font></td></tr>
    
<tr><td bgcolor="#ffc8d8"><tt>&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%">Methods defined here:<br>
<dl><dt><a name="EMix-__init__"><strong>__init__</strong></a>(self, pa_mix:list, pi_tool_num:int=99)</dt><dd><tt>Initialize&nbsp;self.&nbsp;&nbsp;See&nbsp;help(type(self))&nbsp;for&nbsp;accurate&nbsp;signature.</tt></dd></dl>

<dl><dt><a name="EMix-m164"><strong>m164</strong></a>(self, pi_tool_id:int=-1)</dt><dd><tt>Read-only&nbsp;-&nbsp;Setting&nbsp;the&nbsp;mixing&nbsp;values&nbsp;of&nbsp;a&nbsp;virtual&nbsp;extruder<br>
requires&nbsp;M163&nbsp;and&nbsp;M164&nbsp;commands.<br>
&nbsp;<br>
:param&nbsp;pi_tool_id:&nbsp;Typically&nbsp;&nbsp;0&nbsp;to&nbsp;15&nbsp;the&nbsp;number&nbsp;of&nbsp;virtual&nbsp;extruders&nbsp;is&nbsp;defined&nbsp;in&nbsp;the&nbsp;firmware&nbsp;(Marlin)<br>
:return:&nbsp;String&nbsp;with&nbsp;the&nbsp;GCode&nbsp;to&nbsp;set&nbsp;the&nbsp;virtual&nbsp;tool&nbsp;values.</tt></dd></dl>

<dl><dt><a name="EMix-m165"><strong>m165</strong></a>(self, comment:str='Set colormix')</dt><dd><tt>Read-only<br>
&nbsp;<br>
:param&nbsp;comment:&nbsp;Default&nbsp;=&nbsp;"Set&nbsp;colormix"<br>
:return:&nbsp;String&nbsp;with&nbsp;the&nbsp;GCode&nbsp;to&nbsp;set&nbsp;the&nbsp;color&nbsp;mix&nbsp;to&nbsp;this&nbsp;mixes&nbsp;values</tt></dd></dl>

<dl><dt><a name="EMix-second_retract"><strong>second_retract</strong></a>(self, retract_length:float, comment:str='')</dt><dd><tt>Read-only&nbsp;-&nbsp;Based&nbsp;on&nbsp;the&nbsp;number&nbsp;of&nbsp;filaments&nbsp;retractions&nbsp;have&nbsp;to&nbsp;be&nbsp;'reversed'.<br>
This&nbsp;method&nbsp;returns&nbsp;the&nbsp;gcode&nbsp;for&nbsp;the&nbsp;retraction<br>
or&nbsp;unretraction&nbsp;if&nbsp;the&nbsp;retract_length&nbsp;is&nbsp;negative<br>
&nbsp;<br>
:param&nbsp;retract_length:<br>
:param&nbsp;comment:&nbsp;Default&nbsp;=&nbsp;""<br>
:return:&nbsp;String&nbsp;with&nbsp;the&nbsp;GCode&nbsp;for&nbsp;the&nbsp;given&nbsp;retraction</tt></dd></dl>

<hr>
Static methods defined here:<br>
<dl><dt><a name="EMix-list_to_mix"><strong>list_to_mix</strong></a>(inlist:list)</dt><dd><tt>Given&nbsp;a&nbsp;list&nbsp;that&nbsp;may&nbsp;have&nbsp;empty&nbsp;values&nbsp;convert&nbsp;the&nbsp;elements&nbsp;to&nbsp;float<br>
&nbsp;<br>
Used&nbsp;by&nbsp;Class&nbsp;<a href="#EMix">EMix</a><br>
&nbsp;<br>
:param&nbsp;inlist:<br>
:return:</tt></dd></dl>

<hr>
Data descriptors defined here:<br>
<dl><dt><strong>__dict__</strong></dt>
<dd><tt>dictionary&nbsp;for&nbsp;instance&nbsp;variables&nbsp;(if&nbsp;defined)</tt></dd>
</dl>
<dl><dt><strong>__weakref__</strong></dt>
<dd><tt>list&nbsp;of&nbsp;weak&nbsp;references&nbsp;to&nbsp;the&nbsp;object&nbsp;(if&nbsp;defined)</tt></dd>
</dl>
<dl><dt><strong>emix</strong></dt>
<dd><tt>Read-only<br>
&nbsp;<br>
:return:&nbsp;Percent&nbsp;mix&nbsp;value</tt></dd>
</dl>
<dl><dt><strong>extruders</strong></dt>
<dd><tt>Read-only<br>
&nbsp;<br>
:return:&nbsp;Number&nbsp;of&nbsp;extruders&nbsp;based&nbsp;on&nbsp;mix&nbsp;(2&nbsp;or&nbsp;3&nbsp;values)</tt></dd>
</dl>
<dl><dt><strong>mix</strong></dt>
<dd><tt>Read-only<br>
&nbsp;<br>
:return:&nbsp;Mix&nbsp;value&nbsp;from&nbsp;import</tt></dd>
</dl>
</td></tr></table> <p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#ffc8d8">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#000000" face="helvetica, arial"><a name="RunValues">class <strong>RunValues</strong></a>(<a href="builtins.html#object">builtins.object</a>)</font></td></tr>
    
<tr><td bgcolor="#ffc8d8"><tt>&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%">Methods defined here:<br>
<dl><dt><a name="RunValues-__init__"><strong>__init__</strong></a>(self)</dt><dd><tt>Initialize&nbsp;self.&nbsp;&nbsp;See&nbsp;help(type(self))&nbsp;for&nbsp;accurate&nbsp;signature.</tt></dd></dl>

<dl><dt><a name="RunValues-generate_stack"><strong>generate_stack</strong></a>(self)</dt><dd><tt>Create&nbsp;the&nbsp;'stack'&nbsp;of&nbsp;ColorBands&nbsp;from&nbsp;the&nbsp;Pattern&nbsp;/&nbsp;Mixes&nbsp;/&nbsp;Cycles&nbsp;/&nbsp;Mode&nbsp;values<br>
&nbsp;<br>
:return:&nbsp;False&nbsp;when&nbsp;the&nbsp;number&nbsp;of&nbsp;layers&nbsp;is&nbsp;unknown</tt></dd></dl>

<dl><dt><a name="RunValues-load_if_present"><strong>load_if_present</strong></a>(self, names:list=None)</dt><dd><tt>Scan&nbsp;for&nbsp;a&nbsp;list&nbsp;of&nbsp;value&nbsp;pairs&nbsp;in&nbsp;the&nbsp;dictionary&nbsp;and&nbsp;load&nbsp;into<br>
the&nbsp;<a href="#RunValues">RunValues</a>&nbsp;if&nbsp;possible.<br>
&nbsp;<br>
:param&nbsp;names:&nbsp;List&nbsp;of&nbsp;names&nbsp;to&nbsp;process<br>
:return:&nbsp;True&nbsp;if&nbsp;mixes&nbsp;have&nbsp;been&nbsp;defined,&nbsp;False&nbsp;if&nbsp;color&nbsp;is&nbsp;not&nbsp;available</tt></dd></dl>

<dl><dt><a name="RunValues-m165"><strong>m165</strong></a>(self, pi_layer:int, comment='Set colormix')</dt><dd><tt>Color&nbsp;mix&nbsp;for&nbsp;a&nbsp;layer<br>
&nbsp;<br>
:param&nbsp;pi_layer:<br>
:param&nbsp;comment:<br>
:return:&nbsp;String&nbsp;of&nbsp;GCode&nbsp;setting&nbsp;the&nbsp;colormix</tt></dd></dl>

<dl><dt><a name="RunValues-m165_equal"><strong>m165_equal</strong></a>(self, comment='Equal colormix for retraction')</dt><dd><tt>GCode&nbsp;for&nbsp;setting&nbsp;each&nbsp;extruder&nbsp;to&nbsp;the&nbsp;same&nbsp;value&nbsp;to&nbsp;prepare<br>
for&nbsp;retraction.<br>
&nbsp;<br>
:param&nbsp;comment:&nbsp;Default&nbsp;=&nbsp;"Equal&nbsp;colormix&nbsp;for&nbsp;retraction"<br>
:return:&nbsp;String&nbsp;of&nbsp;GCode&nbsp;for&nbsp;setting&nbsp;the&nbsp;colormix</tt></dd></dl>

<dl><dt><a name="RunValues-pattern_index"><strong>pattern_index</strong></a>(self, layer_num:int)</dt><dd><tt>Given&nbsp;a&nbsp;layer&nbsp;return&nbsp;the&nbsp;pattern_index&nbsp;value&nbsp;to&nbsp;the&nbsp;mixes&nbsp;list&nbsp;from&nbsp;the<br>
color_bands.<br>
&nbsp;<br>
:param&nbsp;layer_num:<br>
:return:&nbsp;The&nbsp;index&nbsp;of&nbsp;the&nbsp;mixes&nbsp;array&nbsp;for&nbsp;the&nbsp;specified&nbsp;layer</tt></dd></dl>

<hr>
Static methods defined here:<br>
<dl><dt><a name="RunValues-parse_mixes"><strong>parse_mixes</strong></a>(template:str, is_tool=False)</dt><dd><tt>Given&nbsp;a&nbsp;string&nbsp;of&nbsp;two&nbsp;or&nbsp;three&nbsp;values&nbsp;delimited&nbsp;with&nbsp;/&nbsp;and<br>
separated&nbsp;with&nbsp;something&nbsp;other&nbsp;than&nbsp;spaces&nbsp;which&nbsp;are&nbsp;removed.<br>
The&nbsp;number&nbsp;of&nbsp;value&nbsp;sets&nbsp;establishes&nbsp;the&nbsp;number&nbsp;of&nbsp;Extruders<br>
when&nbsp;use&nbsp;with&nbsp;the&nbsp;<a href="#EMix">EMix</a>&nbsp;class.<br>
or<br>
For&nbsp;example:<br>
&nbsp;<br>
&nbsp;<a href="#RunValues">RunValues</a>.<a href="#RunValues-parse_mixes">parse_mixes</a>("10/90,40/60,0/100,85/15")<br>
&nbsp;<br>
&nbsp;<a href="#RunValues">RunValues</a>.<a href="#RunValues-parse_mixes">parse_mixes</a>("10/10/80&nbsp;-&nbsp;0/100/0&nbsp;-&nbsp;33/33/34&nbsp;-&nbsp;100/0/0&nbsp;-&nbsp;10/30/60")<br>
&nbsp;<br>
&nbsp;<br>
&nbsp;<br>
:param&nbsp;template:&nbsp;two&nbsp;or&nbsp;three&nbsp;values&nbsp;delimited&nbsp;with&nbsp;'/'<br>
:param&nbsp;is_tool:&nbsp;True&nbsp;assigns&nbsp;assigns&nbsp;a&nbsp;tool&nbsp;ID&nbsp;0-n&nbsp;(Typically&nbsp;there&nbsp;are&nbsp;16&nbsp;virtual&nbsp;extruders)<br>
:return:&nbsp;List&nbsp;of&nbsp;<a href="#EMix">EMix</a>&nbsp;<a href="builtins.html#object">object</a>&nbsp;or&nbsp;None&nbsp;if&nbsp;parse&nbsp;is&nbsp;not&nbsp;successful<br>
&nbsp;<br>
NOTE:&nbsp;&nbsp;To&nbsp;convert&nbsp;a&nbsp;template&nbsp;to&nbsp;a&nbsp;list&nbsp;of&nbsp;mixes&nbsp;for&nbsp;use&nbsp;with&nbsp;the&nbsp;ColorWheel&nbsp;<a href="builtins.html#object">object</a>:<br>
&nbsp;&nbsp;&nbsp;&nbsp;mixes&nbsp;=&nbsp;list(map(<a href="#EMix">EMix</a>,<a href="#RunValues-parse_mixes">parse_mixes</a>("10/10/80,20/20/60,30/30/40,&nbsp;40/40/20"))</tt></dd></dl>

<hr>
Data descriptors defined here:<br>
<dl><dt><strong>__dict__</strong></dt>
<dd><tt>dictionary&nbsp;for&nbsp;instance&nbsp;variables&nbsp;(if&nbsp;defined)</tt></dd>
</dl>
<dl><dt><strong>__weakref__</strong></dt>
<dd><tt>list&nbsp;of&nbsp;weak&nbsp;references&nbsp;to&nbsp;the&nbsp;object&nbsp;(if&nbsp;defined)</tt></dd>
</dl>
<dl><dt><strong>build_height</strong></dt>
<dd><tt>Height&nbsp;of&nbsp;the&nbsp;build.<br>
&nbsp;<br>
:return:&nbsp;Build&nbsp;height&nbsp;either&nbsp;calculated&nbsp;or&nbsp;as&nbsp;specified.</tt></dd>
</dl>
<dl><dt><strong>colorname_values</strong></dt>
<dd><tt>Parses&nbsp;string&nbsp;to&nbsp;list&nbsp;of&nbsp;colornames&nbsp;in&nbsp;";&nbsp;colorwheel_colornames&nbsp;=&nbsp;..."&nbsp;setting&nbsp;is&nbsp;provided.<br>
&nbsp;<br>
:return:&nbsp;String&nbsp;of&nbsp;color&nbsp;names</tt></dd>
</dl>
<dl><dt><strong>colornames</strong></dt>
<dd><tt>List&nbsp;of&nbsp;colorname&nbsp;values&nbsp;if&nbsp;provided&nbsp;in&nbsp;a&nbsp;";&nbsp;colorwheel_colors&nbsp;=&nbsp;..."&nbsp;setting<br>
&nbsp;<br>
:return:&nbsp;String&nbsp;of&nbsp;colornames</tt></dd>
</dl>
<dl><dt><strong>has_color</strong></dt>
<dd><tt>Read-only&nbsp;-&nbsp;Flag&nbsp;set&nbsp;when&nbsp;color&nbsp;mixing&nbsp;values&nbsp;is&nbsp;seen&nbsp;by&nbsp;the&nbsp;process_if_present()&nbsp;method<br>
&nbsp;<br>
:return:&nbsp;True&nbsp;if&nbsp;colorwheel_mixes&nbsp;has&nbsp;been&nbsp;processed&nbsp;(ie&nbsp;color&nbsp;information&nbsp;exists)</tt></dd>
</dl>
<dl><dt><strong>layer_count</strong></dt>
<dd><tt>Maintains&nbsp;sync&nbsp;between&nbsp;layer_count&nbsp;and&nbsp;build_height<br>
&nbsp;<br>
:return:&nbsp;Number&nbsp;of&nbsp;layers&nbsp;in&nbsp;the&nbsp;build</tt></dd>
</dl>
<dl><dt><strong>mix_values</strong></dt>
<dd><tt>Maintains&nbsp;list&nbsp;of&nbsp;color&nbsp;mixes&nbsp;used&nbsp;to&nbsp;create&nbsp;the&nbsp;list&nbsp;of&nbsp;EMIx&nbsp;values&nbsp;(mixes)<br>
&nbsp;<br>
:return:&nbsp;String&nbsp;of&nbsp;color&nbsp;mix&nbsp;values&nbsp;provide&nbsp;in&nbsp;a&nbsp;";&nbsp;colorwheel_mixes&nbsp;=&nbsp;..."&nbsp;setting</tt></dd>
</dl>
<dl><dt><strong>mixes</strong></dt>
<dd><tt>Read-only&nbsp;-&nbsp;Set&nbsp;by&nbsp;mix_values&nbsp;setter<br>
&nbsp;<br>
:return:&nbsp;List&nbsp;of&nbsp;EMix&nbsp;objects,&nbsp;one&nbsp;for&nbsp;each&nbsp;color&nbsp;mix&nbsp;value</tt></dd>
</dl>
<dl><dt><strong>pattern</strong></dt>
<dd><tt>Read-only&nbsp;list&nbsp;of&nbsp;index&nbsp;values&nbsp;to&nbsp;the&nbsp;color&nbsp;mixes.&nbsp;&nbsp;The&nbsp;pattern&nbsp;controls<br>
the&nbsp;application&nbsp;of&nbsp;the&nbsp;colormixes.&nbsp;&nbsp;This&nbsp;is&nbsp;the&nbsp;parsed&nbsp;results&nbsp;set&nbsp;by<br>
";&nbsp;colorwheel_pattern&nbsp;=&nbsp;..."&nbsp;setting.<br>
&nbsp;<br>
:return:&nbsp;List&nbsp;of&nbsp;index&nbsp;values&nbsp;to&nbsp;the&nbsp;mixes&nbsp;list</tt></dd>
</dl>
<dl><dt><strong>pattern_values</strong></dt>
<dd><tt>Maintain&nbsp;the&nbsp;pattern&nbsp;list&nbsp;when&nbsp;a&nbsp;pattern&nbsp;value&nbsp;from&nbsp;";&nbsp;colorwheel_pattern&nbsp;=&nbsp;..."&nbsp;is&nbsp;processed<br>
&nbsp;<br>
:return:&nbsp;Value&nbsp;from&nbsp;the&nbsp;";&nbsp;colorwheel_pattern&nbsp;=&nbsp;..."&nbsp;setting</tt></dd>
</dl>
<dl><dt><strong>retract_length</strong></dt>
<dd><tt>This&nbsp;value&nbsp;may&nbsp;not&nbsp;be&nbsp;available&nbsp;until&nbsp;after&nbsp;Layer&nbsp;0&nbsp;has&nbsp;been&nbsp;seen&nbsp;and&nbsp;a&nbsp;retraction&nbsp;has&nbsp;occurred.<br>
A&nbsp;value&nbsp;of&nbsp;-0.01&nbsp;(less&nbsp;than&nbsp;zero)&nbsp;to&nbsp;flag&nbsp;it's&nbsp;state.&nbsp;&nbsp;This&nbsp;assures&nbsp;0.0&nbsp;is&nbsp;returned&nbsp;instead&nbsp;of<br>
that&nbsp;flag&nbsp;if&nbsp;the&nbsp;value&nbsp;has&nbsp;not&nbsp;been&nbsp;set.<br>
&nbsp;<br>
:return:&nbsp;float&nbsp;with&nbsp;length&nbsp;specified&nbsp;for&nbsp;retractions&nbsp;or&nbsp;0.0&nbsp;if&nbsp;a&nbsp;value&nbsp;hasn't&nbsp;been&nbsp;set</tt></dd>
</dl>
<dl><dt><strong>stack_report</strong></dt>
<dd><tt>Generates&nbsp;a&nbsp;table&nbsp;of&nbsp;colormix&nbsp;values&nbsp;and&nbsp;the&nbsp;layers&nbsp;they&nbsp;apply&nbsp;to.<br>
&nbsp;<br>
:return:&nbsp;String&nbsp;containing&nbsp;the&nbsp;report.</tt></dd>
</dl>
<dl><dt><strong>toolmix_values</strong></dt>
<dd><tt>Maintain&nbsp;list&nbsp;of&nbsp;toolmixes&nbsp;when&nbsp;toolmix_values&nbsp;is&nbsp;set<br>
&nbsp;<br>
:return:&nbsp;String&nbsp;of&nbsp;values&nbsp;for&nbsp;tool&nbsp;mixes&nbsp;(unparsed)</tt></dd>
</dl>
<dl><dt><strong>toolmixes</strong></dt>
<dd><tt>Read-only&nbsp;-&nbsp;Set&nbsp;by&nbsp;toolmix_values<br>
&nbsp;<br>
:return:&nbsp;List&nbsp;of&nbsp;EMix&nbsp;Tools&nbsp;if&nbsp;defined&nbsp;by&nbsp;";&nbsp;tool_mixes&nbsp;=&nbsp;...""</tt></dd>
</dl>
</td></tr></table></td></tr></table><p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#55aa55">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Data</strong></big></font></td></tr>
    
<tr><td bgcolor="#55aa55"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><strong>FINDALL_MIX_RE</strong> = re.compile('^\\s*;\\s*((colorwheel_|tool_|retract_length|layer_height|LAYER_COUNT).*)\\s*[=:](.*)$')<br>
<strong>LAYER_NUM_RE</strong> = re.compile('^\\s*;\\s*LAYER:\\s*(\\d+)\\s*$')<br>
<strong>MIXES_RE</strong> = re.compile('(\\d+)/(\\d+)/*(\\d+)*')<br>
<strong>RELATIVE_MIX_RE</strong> = re.compile('(\\d+\\.*\\d*)/(\\d+\\.*\\d*)')<br>
<strong>RETRACT_RE</strong> = re.compile('\\s*E-(\\d+\\.*\\d*)')<br>
<strong>UNRETRACT_RE</strong> = re.compile('\\s*E(\\d+\\.*\\d*)')<br>
<strong>VALUES_RE</strong> = re.compile('^\\s*;\\s*(.*)\\s*[=:](.*)')</td></tr></table>
</body></html>